// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Rattail CE.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const DWORD dwAdornmentFlags = 0; // exit button

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_SAVE_X, OnFileSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if(!m_wndCommandBar.Create(this) ||
	   !m_wndCommandBar.InsertMenuBar(IDR_MAINFRAME) ||
	   !m_wndCommandBar.AddAdornments(dwAdornmentFlags))
	{
		TRACE0("Failed to create CommandBar\n");
		return -1;      // fail to create
	}

	m_wndCommandBar.SetBarStyle(m_wndCommandBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_FIXED);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs


	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnFileSave() 
{
	CDocument* pDocument;
	CString* pPath;
	CFile destFile;
	CArchive* ar;
	BOOL bResult;
	
	pDocument = GetActiveDocument();
	if (! pDocument)
		return;

	pPath = GetNewPath();
	if (! pPath)
		return;

	bResult = destFile.Open(*pPath, CFile::modeCreate | CFile::modeWrite | CFile::shareExclusive);
	delete pPath;
	if (! bResult)
		return;

	ar = new CArchive(&destFile, CArchive::store);
	pDocument->Serialize(*ar);
	ar->Flush();
	ar->Close();
	destFile.Close();
	delete ar;
}

CString* CMainFrame::GetNewPath()
{
	WIN32_FIND_DATA FindData;
	HANDLE hFindFile;
	BOOL bResult;
	UINT i;
	CString folder = DOCUMENTS_FOLDER;
	CString* pPath;
	
	hFindFile = FindFirstFile(folder, &FindData);
	FindClose(hFindFile);
	if (hFindFile == INVALID_HANDLE_VALUE) {
		bResult = CreateDirectory(folder, NULL);
		if (! bResult)
			return NULL;
	}

	pPath = new CString;
	for (i = 1; i <= 1024; i++) {
		pPath->Format(L"%s\\Batch %04u", folder, i);
		hFindFile = FindFirstFile(*pPath, &FindData);
		FindClose(hFindFile);
		if (hFindFile == INVALID_HANDLE_VALUE) {
			return pPath;
		}
	}

	return NULL;
}
