// Rattail CEView.h : interface of the CRattailCEView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_RATTAILCEVIEW_H__9EA36B28_60E4_4345_9342_8125EE0D5B61__INCLUDED_)
#define AFX_RATTAILCEVIEW_H__9EA36B28_60E4_4345_9342_8125EE0D5B61__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ScanCApi.h"

class CRattailCEView : public CFormView
{
protected: // create from serialization only
	CRattailCEView();
	DECLARE_DYNCREATE(CRattailCEView)

public:
	//{{AFX_DATA(CRattailCEView)
	enum { IDD = IDD_RATTAILCE_FORM };
	CButton	m_StopUnit;
	CEdit	m_UnitQuantity;
	CButton	m_StopCase;
	CEdit	m_CaseQuantity;
	CListCtrl	m_Scans;
	CEdit	m_Scancode;
	//}}AFX_DATA

// Attributes
public:
	CRattailCEDoc* GetDocument();

// Operations
public:
	void CloseScanner();
	void DisableScanner();
	BOOL EnableScanner();
	BOOL OpenScanner();
	bool ProcessScan();
	bool StoreScanData();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRattailCEView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRattailCEView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	bool m_bInited;
	HANDLE m_hScanner;
	LPSCAN_BUFFER m_lpScanBuffer;
	DWORD m_dwRequestID;

// Generated message map functions
protected:
	//{{AFX_MSG(CRattailCEView)
	afx_msg void OnClickScans(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnScancodeSetfocus();
	afx_msg void OnScancodeKillfocus();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in Rattail CEView.cpp
inline CRattailCEDoc* CRattailCEView::GetDocument()
   { return (CRattailCEDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RATTAILCEVIEW_H__9EA36B28_60E4_4345_9342_8125EE0D5B61__INCLUDED_)
